Package qsardes.descriptor

# Interface Descriptor

All Known Implementing Classes:
  `DescriptorAcgc`, `DescriptorAdjacencyMatrix`, `DescriptorAlogp`, `DescriptorApol`, `DescriptorAromAtomCount`, `DescriptorAromBondCount`, `DescriptorAtomCount`, `DescriptorAutocorrelation`, `DescriptorBaryszMatrix`, `DescriptorBasicGroupCount`, `DescriptorBcut`, `DescriptorBondCount`, `DescriptorBpol`, `DescriptorBurdenModifiedEigenvalues`, `DescriptorCarbonTypes`, `DescriptorChiChain`, `DescriptorChiCluster`, `DescriptorChiPath`, `DescriptorChiPathCluster`, `DescriptorConstitutional`, `DescriptorCrippen`, `DescriptorDetourMatrix`, `DescriptorEccentricConnectIndex`, `DescriptorElectrTopolStateIndex`, `DescriptorExtendedTopochemIndex`, `DescriptorFingerprintEstate`, `DescriptorFingerprintEstateCount`, `DescriptorFingerprintKlekotaRoth`, `DescriptorFingerprintKlekotaRothCount`, `DescriptorFingerprintPubchem`, `DescriptorFingerprintSubstructure`, `DescriptorFingerprintSubstructureCount`, `DescriptorFMF`, `DescriptorFractionalCsp3`, `DescriptorFractionalPsa`, `DescriptorFragmentComplexity`, `DescriptorHBondAcceptorsCount`, `DescriptorHBondDonorsCount`, `DescriptorHybridizationRatio`, `DescriptorInformationContent`, `DescriptorJplogp`, `DescriptorKappaShapeIndex`, `DescriptorLargestChain`, `DescriptorLargestPiSystem`, `DescriptorLongestAliphaticChain`, `DescriptorMannholdLogp`, `DescriptorMlfer`, `DescriptorMolecularDistanceEdge`, `DescriptorPathCount`, `DescriptorPetitjeanNumber`, `DescriptorRingCount`, `DescriptorRotatableBondsCount`, `DescriptorRuleOfFive`, `DescriptorSpiroAtomCount`, `DescriptorTopological`, `DescriptorTopologicalCharge`, `DescriptorTopologicalDistance`, `DescriptorTopologicalPolarSurfaceArea`, `DescriptorVanDerWaalsVolume`, `DescriptorVertexAdjacencyMatrix`, `DescriptorWalkCount`, `DescriptorWeight`, `DescriptorWeightedPath`, `DescriptorWienerNumbers`, `DescriptorXlogp`, `DescriptorZagrebIndex`, `QsarMEAromBondCount`, `QsarMEAtomCount`, `QsarMEAutocorrelation`, `QsarMEBaryszMatrix`, `QsarMEBondCount`, `QsarMEBurdenModifiedEigenvalues`, `QsarMECarbonTypes`, `QsarMEChiChain`, `QsarMEChiPath`, `QsarMEChiPathCluster`, `QsarMEConstitutional`, `QsarMEDetourMatrix`, `QsarMEElectrTopolStateIndex`, `QsarMEExtendedTopochemIndex`, `QsarMEFingerprintKlekotaRoth`, `QsarMEFingerprintKlekotaRothCount`, `QsarMEFingerprintPubchem`, `QsarMEFingerprintSubstructure`, `QsarMEFingerprintSubstructureCount`, `QsarMEFMF`, `QsarMEFragmentComplexity`, `QsarMEHBondAcceptorsCount`, `QsarMEHBondDonorsCount`, `QsarMEHybridizationRatio`, `QsarMEInformationContent`, `QsarMEKappaShapeIndex`, `QsarMELargestChain`, `QsarMELargestPiSystem`, `QsarMELongestAliphaticChain`, `QsarMEMannholdLogp`, `QsarMEMlfer`, `QsarMEMolecularDistanceEdge`, `QsarMEPathCount`, `QsarMERingCount`, `QsarMERotatableBondsCount`, `QsarMERuleOfFive`, `QsarMETopological`, `QsarMETopologicalCharge`, `QsarMETopologicalDistance`, `QsarMETopologicalPolarSurfaceArea`, `QsarMEVertexAdjacencyMatrix`, `QsarMEWalkCount`, `QsarMEWeight`, `QsarMEWeightedPath`, `QsarMEWienerNumbers`, `QsarWBAcgc`, `QsarWBAdjacencyMatrix`, `QsarWBAlogp`, `QsarWBApol`, `QsarWBAromAtomCount`, `QsarWBAromBondCount`, `QsarWBAtomCount`, `QsarWBAutocorrelation`, `QsarWBBaryszMatrix`, `QsarWBBasicGroupCount`, `QsarWBBcut`, `QsarWBBondCount`, `QsarWBBpol`, `QsarWBBurdenModifiedEigenvalues`, `QsarWBCarbonTypes`, `QsarWBChiChain`, `QsarWBChiCluster`, `QsarWBChiPath`, `QsarWBChiPathCluster`, `QsarWBConstitutional`, `QsarWBCrippen`, `QsarWBDetourMatrix`, `QsarWBEccentricConnectIndex`, `QsarWBElectrTopolStateIndex`, `QsarWBExtendedTopochemIndex`, `QsarWBFingerprintEstate`, `QsarWBFingerprintEstateCount`, `QsarWBFingerprintKlekotaRoth`, `QsarWBFingerprintKlekotaRothCount`, `QsarWBFingerprintPubchem`, `QsarWBFingerprintSubstructure`, `QsarWBFingerprintSubstructureCount`, `QsarWBFMF`, `QsarWBFractionalCsp3`, `QsarWBFractionalPsa`, `QsarWBFragmentComplexity`, `QsarWBHBondAcceptorsCount`, `QsarWBHBondDonorsCount`, `QsarWBHybridizationRatio`, `QsarWBInformationContent`, `QsarWBJplogp`, `QsarWBKappaShapeIndex`, `QsarWBLargestChain`, `QsarWBLargestPiSystem`, `QsarWBLongestAliphaticChain`, `QsarWBMannholdLogp`, `QsarWBMlfer`, `QsarWBMolecularDistanceEdge`, `QsarWBPathCount`, `QsarWBPetitjeanNumber`, `QsarWBRingCount`, `QsarWBRotatableBondsCount`, `QsarWBRuleOfFive`, `QsarWBSpiroAtomCount`, `QsarWBTopological`, `QsarWBTopologicalCharge`, `QsarWBTopologicalDistance`, `QsarWBTopologicalPolarSurfaceArea`, `QsarWBVanDerWaalsVolume`, `QsarWBVertexAdjacencyMatrix`, `QsarWBWalkCount`, `QsarWBWeight`, `QsarWBWeightedPath`, `QsarWBWienerNumbers`, `QsarWBXlogp`, `QsarWBZagrebIndex`

public interface Descriptor
Descriptor calculator classes interface.
The following literature has been consulted for the descriptors calculators development.
Burden, F. R. (1997). A chemically intuitive molecular index based on the eigenvalues of a modified adjacency matrix. Quantitative Structure‐Activity Relationships, 16(4), 309-314.
Consonni, V., Todeschini, R. (2010). Molecular Descriptors. In: Puzyn, T. et al. Recent Advances in QSAR Studies. Challenges and Advances in Computational Chemistry and Physics, vol 8. Springer, Dordrecht.
Edusoft-LC (2008). Molconn-Z version 4.10 documentation.
Gramatica, P., et al. (2000). Modelling and prediction of soil sorption coefficients of non-ionic organic pesticides by molecular descriptors. Chemosphere, 41(5), 763-777.
Hall, L. H., et al. (1991). The electrotopological state: structure information at the atomic level for molecular graphs. Journal of chemical information and computer sciences, 31(1), 76-82.
Hall, L. H., & Kier, L. B. (1995). Electrotopological state indices for atom types: a novel combination of electronic, topological, and valence state information. Journal of Chemical Information and Computer Sciences, 35(6), 1039-1045.
Hall, L. H., et al. (1995). Molecular similarity based on novel atom-type electrotopological state indices. Journal of chemical information and computer sciences, 35(6), 1074-1080.
Kellogg, G. E., et al. (1996). E-state fields: Applications to 3D QSAR. Journal of computer-aided molecular design, 10(6), 513-520.
Kier, L. B., & Hall, L. H. (1986). Molecular Connectivity in Structure-Activity Analysis. Research studies press LTD.
Kier, L. B., & Hall, L. H. (1990). An electrotopological-state index for atoms in molecules. Pharmaceutical research, 7(8), 801-807.
Kier, L. B., et al. (1991). An index of electrotopological state for atoms in molecules. Journal of Mathematical Chemistry, 7(1), 229-241.
Kier, L. B., & Hall, L. H. (1997). The E-State as an extended free valence. Journal of Chemical Information and Computer Sciences, 37(3), 548-552.
McGillen, M. R., et al. (2024). The use of the electrotopological state as a basis for predicting hydrogen abstraction rate coefficients: a proof of principle for the reactions of alkanes and haloalkanes with OH. Environmental Science: Atmospheres, 4(1), 18-34.
Mordred online documentation (2025). https://mordred-descriptor.github.io/documentation/master/
Moriwaki, H. et al. (2018). Mordred: a molecular descriptor calculator. Journal of cheminformatics, 10(1), 4.
Nilakantan, R., et al. (2006). A family of ring system-based structural fragments for use in Structure− Activity studies: Database mining and recursive partitioning. Journal of chemical information and modeling, 46(3), 1069-1077.
Roy, K., & Ghosh, G. (2004). QSTR with extended topochemical atom indices. 2. Fish toxicity of substituted benzenes. Journal of chemical information and computer sciences, 44(2), 559-567.
Roy, K., & Das, R. N. (2011). On some novel extended topochemical atom (ETA) parameters for effective encoding of chemical information and modelling of fundamental physicochemical properties. SAR and QSAR in Environmental Research, 22(5-6), 451-472.
Roy, K., & Kabir, H. (2012). QSPR with extended topochemical atom (ETA) indices: Modeling of critical micelle concentration of non-ionic surfactants. Chemical engineering science, 73, 86-98.
Todeschini, R. & Consonni, V. (2000). Handbook of Molecular Descriptors. Wiley VCH.
Todeschini, R. & Consonni, V. (2009). Molecular Descriptors for Chemoinformatics. Wiley VCH.
Trinajstić, N., Nikolić, S., Lučić, B., Amić, D., & Mihalić, Z. (1997). The detour matrix in chemistry. Journal of chemical information and computer sciences, 37(4), 631-638.
Petitjean, M. (1992). Applications of the radius-diameter diagram to the classification of topological and geometrical shapes of chemical compounds. Journal of chemical information and computer sciences, 32(4), 331-337.
Platts, J. A., et al. (1999). Estimation of molecular linear free energy relation descriptors using a group contribution approach. Journal of Chemical Information and Computer Sciences, 39(5), 835-845.
U.S Environmental Protection Agency (2008). Molecular descriptors guide version 1.0.2.
Wagener, M., et al. (1995). Autocorrelation of molecular surface properties for modeling corticosteroid binding globulin and cytosolic Ah receptor activity by neural networks. Journal of the American Chemical Society, 117(29), 7769-7775.
Yap, Chun Wei (2011). PaDEL-descriptor: An open source software to calculate molecular descriptors and fingerprints. Journal of computational chemistry. 32(7), 1466-1474.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<String>`
  `get_descriptor_names()`
  Gets descriptors names.
  `DescriptorType`
  `get_descriptor_type()`
  Gets the descriptor class type.
  `Map<String,String>`
  `get_descriptor_values(AbstractMoleculeBuilder mol_build)`
  Calculates descriptors values.

- ## Method Details

  - ### get_descriptor_type

    DescriptorType get_descriptor_type()
    Gets the descriptor class type.
    Returns:
      Descriptor class type.

  - ### get_descriptor_names

    List<String> get_descriptor_names()
    Gets descriptors names.
    Returns:
      Descriptor names.

  - ### get_descriptor_values

    Map<String,String> get_descriptor_values(AbstractMoleculeBuilder mol_build)
    Calculates descriptors values.
    Parameters:
      `mol_build` - Molecular builder representation.
    Returns:
      Descriptor values mapped as name:value.